<?php
declare(strict_types=1);

namespace FiloBlu\Esb\Core\Expression;

use Magento\Framework\DataObject;

use function is_string;

/**
 * Class VariableExpander
 * @package FiloBlu\Esb\Core\Expression
 */
class VariableExpander implements VariableExpanderInterface
{
    /**
     * @param array|mixed|string|null $value
     * @param DataObject $data
     * @return array|mixed|string|null
     */
    public function expand($value, DataObject $data)
    {
        if (!is_string($value)) {
            return $value;
        }

        return preg_replace_callback(
            '/{(.*?)}/',
            static function($match) use ($data) {
                return $data->getDataByPath($match[1]);
            },
            $value
        );
    }
}
